//*****************************************************************
// 
//  JAVA Source for com.idautomation.linear; 2012
//  
//	Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************


package com.idautomation.linear;

import java.awt.*;
import java.applet.*;

/** This is the applet that contains all linear barcode functionality. */

public class BCApplet extends Applet
{
        // ** updated for servlet operation 5/31/2001
	public BarCode BC=null;
        public boolean isStandalone=false;
        // ** end of update

	public BCApplet() {
		this.setLayout(new java.awt.BorderLayout());
	}

	public void start() {
		//BC.autoSize=false;
		BC.paint(this.getGraphics());
	}

	public void refresh() {
                BC.paint(BC.getGraphics());
		this.paintAll(this.getGraphics());
	}

	public void init() {
		// create bar code 1D
		if (BC==null) BC=new BarCode();	
		
		this.add("Center",BC);	
		initParam("CODE_TYPE");
                initParam("S");
		initParam("N");
		initParam("X");
		initParam("I");
		initParam("H");
		initParam("BAR_HEIGHT");
                initParam("BH");
		initParam("CODABAR_START");
                initParam("CBSTART");
		initParam("CODABAR_STOP");
                initParam("CBSTOP");
		initParam("BAR_COLOR");
                initParam("BC");
		initParam("FONT_COLOR");
                initParam("FC");
		initParam("TEXT_FONT");
                initParam("F");
                initParam("FS");
		initParam("UPCE_SYSTEM");
                initParam("UES");
		initParam("BACK_COLOR");
                initParam("BGC");
		initParam("CODE128_SET");
                initParam("CS");
		initParam("LEFT_MARGIN");
                initParam("LM");
		initParam("TOP_MARGIN");
                initParam("TM");
		initParam("CHECK_CHAR");
                initParam("CC");
		initParam("BARCODE");
                initParam("D");
		initParam("GUARDBARS");
		initParam("ROTATE");
                initParam("O");
		initParam("SUPPLEMENT");
                initParam("SUP");
		initParam("SUPPLEMENT_CODE");
                initParam("SUPD");
		initParam("SUPPLEMENT_HEIGHT");
                initParam("SUPH");
		initParam("SUPPLEMENT_SEPARATION");
                initParam("SEP");
		initParam("POSTNET_TALL");
                initParam("PNT");
		initParam("POSTNET_SHORT");
                initParam("PNS");
		initParam("CHECK_CHARINTEXT");
                initParam("CT");
		initParam("ST");		
		initParam("PT");
		initParam("TEXT_MARGIN");
                initParam("EM");
                initParam("BEARERBAR_HORIZONTAL");
                initParam("BBH");
		initParam("BEARERBAR_VERTICAL");
                initParam("BBV");
		initParam("CHARACTER_GROUPING");
                initParam("CG");
		initParam("WHITE_BAR_INCREASE");
                initParam("WI");
		initParam("AUTO_SIZE");
                initParam("HEIGHT");
                initParam("H");
                initParam("WIDTH");
                initParam("W");
                initParam("IR");
	}

	private void initParam(String p) {
		String v=getStringParam(p,"");
		if (v.length()==0) return;
	    setParameter(p,v);
	}

	public void setParameter(String p,String v) 
        {
                if (v==null) return;
                int width = 0;	

		if (p.compareTo("CODE_TYPE")==0) {
			if (v.compareTo("CODE39")==0) BC.barType=BC.CODE39;
			if (v.compareTo("CODE39EXT")==0) BC.barType=BC.CODE39EXT;
			if (v.compareTo("CODE93")==0) BC.barType=BC.CODE93;
			if (v.compareTo("CODE11")==0) BC.barType=BC.CODE11;
			if (v.compareTo("CODABAR")==0) BC.barType=BC.CODABAR;
			if (v.compareTo("CODE93EXT")==0) BC.barType=BC.CODE93EXT;
			if (v.compareTo("CODE128")==0) BC.barType=BC.CODE128;
			if (v.compareTo("MSI")==0) BC.barType=BC.MSI;
			if (v.compareTo("IND25")==0) BC.barType=BC.IND25;
			if (v.compareTo("MAT25")==0) BC.barType=BC.MAT25;
			if (v.compareTo("INTERLEAVED25")==0) BC.barType=BC.INTERLEAVED25;
			if (v.compareTo("EAN13")==0) BC.barType=BC.EAN13;
			if (v.compareTo("EAN8")==0) BC.barType=BC.EAN8;
			if (v.compareTo("UPCA")==0) BC.barType=BC.UPCA;
			if (v.compareTo("UPCE")==0) BC.barType=BC.UPCE;
			if (v.compareTo("POSTNET")==0) BC.barType=BC.POSTNET;
			if (v.compareTo("PLANET")==0) BC.barType=BC.PLANET;
			if (v.compareTo("UCC128")==0) BC.barType=BC.UCC128;
			if (v.compareTo("ONECODE")==0) BC.barType=BC.INTELLIGENTMAIL;
                        if (v.compareTo("INTELLIGENTMAIL")==0) BC.barType=BC.INTELLIGENTMAIL;
		}
                if (p.compareTo("S")==0) {
			if (v.toUpperCase().compareTo("CODE39")==0 || v.compareTo("0")==0) BC.barType=BC.CODE39;
			if (v.toUpperCase().compareTo("CODE39EXT")==0 || v.compareTo("1")==0) BC.barType=BC.CODE39EXT;
			if (v.toUpperCase().compareTo("INTERLEAVED25")==0 || v.compareTo("2")==0) BC.barType=BC.INTERLEAVED25;
			if (v.toUpperCase().compareTo("CODE11")==0 || v.compareTo("3")==0) BC.barType=BC.CODE11;
			if (v.toUpperCase().compareTo("CODABAR")==0 || v.compareTo("4")==0) BC.barType=BC.CODABAR;
			if (v.toUpperCase().compareTo("MSI")==0 || v.compareTo("5")==0) BC.barType=BC.MSI;
			if (v.toUpperCase().compareTo("UPCA")==0 || v.compareTo("6")==0) BC.barType=BC.UPCA;
			if (v.toUpperCase().compareTo("IND25")==0 || v.compareTo("7")==0) BC.barType=BC.IND25;
			if (v.toUpperCase().compareTo("MAT25")==0 || v.compareTo("8")==0) BC.barType=BC.MAT25;
			if (v.toUpperCase().compareTo("CODE93")==0 || v.compareTo("9")==0) BC.barType=BC.CODE93;
			if (v.toUpperCase().compareTo("EAN13")==0 || v.compareTo("10")==0) BC.barType=BC.EAN13;
			if (v.toUpperCase().compareTo("EAN8")==0 || v.compareTo("11")==0) BC.barType=BC.EAN8;
			if (v.toUpperCase().compareTo("UPCE")==0 || v.compareTo("12")==0) BC.barType=BC.UPCE;
			if (v.toUpperCase().compareTo("CODE128")==0 || v.compareTo("13")==0) BC.barType=BC.CODE128;
			if (v.toUpperCase().compareTo("CODE93EXT")==0 || v.compareTo("14")==0) BC.barType=BC.CODE93EXT;
			if (v.toUpperCase().compareTo("POSTNET")==0 || v.compareTo("15")==0) BC.barType=BC.POSTNET;
			if (v.toUpperCase().compareTo("PLANET")==0 || v.compareTo("16")==0) BC.barType=BC.PLANET;
			if (v.toUpperCase().compareTo("UCC128")==0 || v.compareTo("17")==0) BC.barType=BC.UCC128;
			if (v.toUpperCase().compareTo("ONECODE")==0 || v.toUpperCase().compareTo("INTELLIGENTMAIL")==0 || v.compareTo("18")==0) BC.barType=BC.INTELLIGENTMAIL;
		}

		if (p.compareTo("N")==0) BC.N=new Double(v).doubleValue();
		
		if (p.compareTo("SUPPLEMENT_CODE")==0) BC.supplement=v;
                if (p.compareTo("SUPD")==0) BC.supplement=v;
		
		if (p.compareTo("SUPPLEMENT_SEPARATION")==0) BC.supSeparationCM=new Double(v).doubleValue();
                if (p.compareTo("SEP")==0) BC.supSeparationCM=new Double(v).doubleValue();
		
		if (p.compareTo("SUPPLEMENT_HEIGHT")==0) BC.supHeight=new Double(v).doubleValue();
                if (p.compareTo("SUPH")==0) BC.supHeight=new Double(v).doubleValue();
		
		if (p.compareTo("SUPPLEMENT")==0 || p.compareTo("SUP")==0)
                {
		  BC.UPCEANSupplement2=false;
		  BC.UPCEANSupplement5=false;
		  if (v.compareTo("2")==0) BC.UPCEANSupplement2=true;
		  if (v.compareTo("5")==0) BC.UPCEANSupplement5=true;
		}
		
		if (p.compareTo("ROTATE")==0) BC.setRotationAngle((int) (new Double(v).doubleValue()));
                if (p.compareTo("O")==0) BC.setRotationAngle((int) (new Double(v).doubleValue()));
		
		if (p.compareTo("POSTNET_TALL")==0 || p.compareTo("PNT")==0) BC.postnetHeightTallBar=(int) (new Double(v).doubleValue());
		
		if (p.compareTo("POSTNET_SHORT")==0 || p.compareTo("PNS")==0) BC.postnetHeightShortBar=(int) (new Double(v).doubleValue());

		if (p.compareTo("X")==0) BC.X=new Double(v).doubleValue();

		if (p.compareTo("I")==0) BC.I=new Double(v).doubleValue();

		if (p.compareTo("LEFT_MARGIN")==0) BC.leftMarginCM=new Double(v).doubleValue();
                if (p.compareTo("LM")==0) BC.leftMarginCM=new Double(v).doubleValue();
                
		if (p.compareTo("TOP_MARGIN")==0) BC.topMarginCM=new Double(v).doubleValue();
                if (p.compareTo("TM")==0) BC.topMarginCM=new Double(v).doubleValue();

		if (p.compareTo("BAR_COLOR")==0) BC.barColor=convertColor(v);
                if (p.compareTo("BC")==0) BC.barColor=convertColor(v);

                if (p.compareTo("TEXT_FONT")==0) BC.textFont=convertFont(v);
                if (p.compareTo("FONT_COLOR")==0) BC.fontColor=convertColor(v);
                if (p.compareTo("F")==0) BC.textFont=new Font(v,Font.PLAIN,BC.textFont.getSize());
                if (p.compareTo("FS")==0) BC.textFont=BC.textFont.deriveFont(new Float(v).floatValue());
                if (p.compareTo("FC")==0) BC.fontColor=convertColor(v);

		if (p.compareTo("BACK_COLOR")==0) BC.backColor=convertColor(v);
                if (p.compareTo("BGC")==0) BC.backColor=convertColor(v);

		if (p.compareTo("GUARDBARS")==0) BC.guardBars=(v.compareTo("Y")==0);	

		if (p.compareTo("UPCE_SYSTEM")==0) BC.UPCESystem=new String(v+"1").charAt(0);
                if (p.compareTo("UES")==0) BC.UPCESystem=new String(v+"1").charAt(0);

                if (p.compareTo("CODABAR_START")==0 || p.compareTo("CBSTART")==0) BC.CODABARStartChar=new String(v+"A").charAt(0);

                if (p.compareTo("CODABAR_STOP")==0 || p.compareTo("CBSTOP")==0) BC.CODABARStopChar=new String(v+"A").charAt(0);

		

		if (p.compareTo("H")==0) BC.H=new Double(v).doubleValue();

		if (p.compareTo("BARCODE")==0) BC.setDataToEncode(v);
                if (p.compareTo("D")==0) BC.setDataToEncode(v);

		if (p.compareTo("CHECK_CHAR")==0) BC.checkCharacter=(v.compareTo("Y")==0);
                if (p.compareTo("CC")==0)
                {
                    String STParameter = v;
                    if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                       STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                        BC.checkCharacterInText = true;
                    else
                        BC.checkCharacterInText = false;
                }

		if (p.compareTo("CHECK_CHARINTEXT")==0) BC.checkCharacterInText=(v.compareTo("Y")==0);
                if (p.compareTo("CT")==0)
                {
                    String STParameter = v;
                    if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                       STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                        BC.checkCharacterInText = true;
                    else
                        BC.checkCharacterInText = false;
                }

		if (p.compareTo("CODE128_SET")==0) BC.Code128Set=new String(v+"B").charAt(0);
                if (p.compareTo("CS")==0) 
                {
                    char csParam = v.charAt(0);
                    if(csParam >= '0' && csParam <= '3')
                    {
                        switch(csParam)
                        {
                            case '0':
                            {
                                BC.setCode128Set(String.valueOf("AUTO"));
                                break;
                            }
                            case '1':
                            {
                                BC.setCode128Set(String.valueOf("A"));
                                break;
                            }
                            case '2':
                            {
                                BC.setCode128Set(String.valueOf("B"));
                                break;
                            }
                            case '3':
                            {
                                BC.setCode128Set(String.valueOf("C"));
                                break;
                            }
                        }
                    }
                    else
                        BC.setCode128Set(String.valueOf(csParam));
                }                

		if (p.compareTo("BAR_HEIGHT")==0) BC.barHeightCM=new Double(v).doubleValue();
                if (p.compareTo("BH")==0) BC.barHeightCM=new Double(v).doubleValue();
		
//		if (p.compareTo("AUTO_SIZE")==0) BC.autoSize=(v.compareTo("TRUE")==0); 
//		
//		if (p.compareTo("HEIGHT")==0) BC.pHeight=(int)new Double(v).doubleValue();
//
//		if (p.compareTo("WIDTH")==0) BC.pWidth=(int)new Double(v).doubleValue();
//                if (p.compareTo("W")==0) BC.pWidth=(int)new Double(v).doubleValue();
                
//                if ((p.compareTo("WIDTH")!=0)  &&(p.compareTo("HEIGHT")!=0))
//                {
//                    BC.autoSize=(v.compareTo("FALSE")==0); 
//                    BC.autoSize=false;
//                    BC.paint(this.getGraphics());
//                }
//                if ((p.compareTo("W")!=0)  &&(p.compareTo("H")!=0))
//                {
//                    BC.autoSize=(v.compareTo("FALSE")==0); 
//                    BC.autoSize=false;
//                    BC.paint(this.getGraphics());
//                }

		if (p.compareTo("TEXT_MARGIN")==0) BC.textMarginCM=new Double(v).doubleValue();
                if (p.compareTo("EM")==0) BC.textMarginCM=new Double(v).doubleValue();

		if (p.compareTo("WHITE_BAR_INCREASE")==0) BC.WhiteBarIncrease=new Float(v).floatValue();
                if (p.compareTo("WI")==0) BC.WhiteBarIncrease=new Float(v).floatValue();
  
                if (p.compareTo("BEARERBAR_HORIZONTAL")==0) BC.BearerBarHori= new Integer(v).intValue();
                if (p.compareTo("BBH")==0) BC.BearerBarHori= new Integer(v).intValue();

                if (p.compareTo("BEARERBAR_VERTICAL")==0) BC.BearerBarVert= new Integer(v).intValue();
                if (p.compareTo("BBV")==0) BC.BearerBarVert= new Integer(v).intValue();

		if (p.compareTo("CHARACTER_GROUPING")==0) BC.ValSpliceText=new Integer(v).intValue();
                if (p.compareTo("CG")==0) BC.ValSpliceText=new Integer(v).intValue();
                if (p.compareTo("IR")==0) BC.setPixelsPerCM(new Integer(v).intValue());
                
                if (p.compareTo("ST")==0)
                {
                    String STParameter = v;
                    if(STParameter.toUpperCase().compareTo("Y") == 0 || STParameter.toUpperCase().compareTo("YES") == 0 ||
                       STParameter.toUpperCase().compareTo("TRUE") == 0 || STParameter.toUpperCase().compareTo("T") == 0)
                        BC.showText = true;
                    else
                        BC.showText = false;
                }
                if (p.compareTo("PT")==0)
                {
                    String PTParameter = v;
                    if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                       PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                        BC.processTilde = true;
                    else
                        BC.processTilde = false;

                }
        }
        // function to convert a String parameter to a color
        public java.awt.Color convertColor(String c) 
        {
            if (c.toUpperCase().compareTo("NULL")==0) return null;
            if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
            if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
            if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
            if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
            if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
            if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
            if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
            if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
            if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
            if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
            if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
            if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
            if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
            try 
            {
                return java.awt.Color.decode(c);
            } 
            catch (Exception e) 
            {
                return java.awt.Color.black;
            }
        }

  // convert an applet parameter to a Font
  public java.awt.Font convertFont(String f) {

    String[] items=convertList(f);

   if (items==null) return null;

    if (items.length<3) return null;

    int s=java.awt.Font.PLAIN;
    if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
    if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

    try {
    return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
    }
    catch (Exception e) {return null;}
  }

  // ** updated for servlet operation 5/31/2001
  // get a parameter as string
  protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);
    }


  //Get a parameter value
  private String getParameter(String key, String def) {


    if (isStandalone) return def;

    if (this.getParameter(key) != null) return this.getParameter(key) ;
    else return def;
  }

  private String[] convertList(String items){

   String[] itema=new String[500];
   int itemCount=0;

   // count number of items
   int p=items.indexOf("|");
   while (p>=0) {
      itema[itemCount++]=items.substring(0,p);
      items=items.substring(p+1,items.length());
      p=items.indexOf("|");
   }

   if (items.compareTo("")!=0) itema[itemCount++]=items;

   if (itemCount==0) return null;

   String[] result=new String[itemCount];
   for (int i=0;i<itemCount;i++) result[i]=itema[i];

   return result;

 }

  private Integer getIntParam(String Param,Integer def) {

    try {
      String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
      return new Integer(s);
    }
    catch(Exception e) {
      return def;
    }
   }

   private Double getDoubleParam(String Param,Double def) {

      try {
       String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
     return new Double(s);
    }
    catch(Exception e) {
      return def;
    }
    }
    // ** end of update
}
